/* SPDX-License-Identifier: BSD-3-Clause */

#ifndef __SO_CONSUMER_H__
#define __SO_CONSUMER_H__

#include <stdio.h>
#include "ring_buffer.h"
#include "packet.h"

typedef struct so_consumer_ctx_t {
	struct so_ring_buffer_t *producer_rb;

    /* TODO: add synchronization primitives for timestamp ordering */
	pthread_mutex_t log_mutex; // mutex for synchronization writing to the log file
	int log_file; // file descriptor for the log file
    pthread_cond_t seq_cond; // condition variable for signaling when the sequence number is reached(maintaing log orde)
    unsigned long next_seq_to_log;// next sequence number to be written to the log file
} so_consumer_ctx_t;

int create_consumers(pthread_t *tids,
					int num_consumers,
					so_ring_buffer_t *rb,
					const char *out_filename);

#endif /* __SO_CONSUMER_H__ */
